#include <bits/stdc++.h>

using namespace std;

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t;

    cin>>t;
    int n,k;
    cin>>n>>k;
    vector<int>v(n);

    for(int i=0;i<n;i++){
       cin>>v[i];
}
int kp=0;
    for(int i=0;i<n;i++){
        if(kp<=v[i]){
            kp++;
        }
        else{
            kp--;
        }
    }
    if(kp==k){
        cout<<"DA"<<endl;
        if(t==1){
        for(int i=0;i<n;i++){
            cout<<v[i]<<endl;
        }}
    }
    else{cout<<"NE"<<endl;}

}